#--------------------------------------------------
#
# equazione diofantina x**3 + y**3 + z**3 = n
#
# by p.p., 15set19
#--------------------------------------------------
#
xmax, ymax, zmax = 5000, 5000, 5000
lista100 = File.new("mordell-list-100.csv","w")
lista100.write("n,x,y,z\n")
lista1k = File.new("mordell-list-1k.csv","w")
lista1k.write("n,x,y,z\n")
#
(1..xmax).each do |x|
	if x % 100 == 0 then print "#" end
	(x..ymax).each do |y|
		(y..zmax).each do |z|
			n = x**3 + y**3 + z**3
			break if n > 1000
			if n > 100 then
				lista1k.write("#{n},#{x},#{y},#{z}\n")
			else
				lista100.write("#{n},#{x},#{y},#{z}\n")
			end
		end
	end
end
print "\n"
#
(1..xmax).each do |x|
	if x % 100 == 0 then print "#" end
	(x..ymax).each do |y|
		n3 = x**3 + y**3
		if n3 < 1000 then zmin = 1  else zmin = ((n3-1000)**(1.0/3)).ceil end
		zmax = ((n3+1000)**(1.0/3)).floor
		(zmin..zmax).each do |z|
			if n3 - z**3 > 0 then
				if n3 - z**3 > 100 then
					lista1k.write("#{n3 - z**3},#{x},#{y},#{-z}\n")
				else
					lista100.write("#{n3 - z**3},#{x},#{y},#{-z}\n")
				end
			else
				if -(n3 - z**3) > 100 then
					lista1k.write("#{-(n3 - z**3)},#{-x},#{-y},#{z}\n")
				else
					lista100.write("#{-(n3 - z**3)},#{-x},#{-y},#{z}\n")
				end
			end
		end	
	end
end
lista100.close
lista1k.close
